\ Final test boot script for CL2
\ 2012.02.02 reserve count.txt

d# 3000 ms
visible

0 0 2value count-file$
0 0 2value count-data$

" int:\runin\count.txt" to count-file$

: write-int ( $filename -- )
   $create-file >r 
   count-data$ " write" r@ $call-method
   drop  r> close-dev
;

: show-result-screen  ( -- )
   pass?  if
      clear-screen
      ." PASS" cr cr
      green-screen
   else
      ." FAIL" cr cr
      red-screen
   then
;

: format-date  ( s m h d m y -- adr len )
   push-decimal
   >r >r >r >r >r >r
   <#
   [char] Z hold
   r> u# u# drop
   r> u# u# drop
   r> u# u# drop
   [char] T hold
   r> u# u# drop
   r> u# u# drop
   r> u# u# u# u#
   u#>
   pop-base
;

\ $rename gives "Unimplemented package interface procedure" on ext2
: do-rename
   2>r  2dup  2r>  $copy  $delete
;

: $safe-delete   ( $name -- )
    2dup $file-exists?  if
       2dup $delete
    then
    2drop
;

: $copy!  ( $src $dst -- )
   2dup $file-exists?  if
      2dup $delete
   then
   $copy1
;

: $safe-rename
   2swap 2dup $file-exists?  if
      2swap $rename
   else
      2drop 2drop
   then
;

0 value s3-fail-count
: s3-power-test
   \ cut off power input
   3b ec-cmd
   5f ec-cmd
   d# 5000 ms
   
   a 0 do
      s3-selftest if
         s3-fail-count 1+ to s3-fail-count
         ."    s3 test fail count: " s3-fail-count .d cr		 
      then
   loop

   \ resume power input
   3c ec-cmd
   d# 10000 ms
   
   s3-fail-count 5 >= if
      ." s3 test fail, power consumption too high during suspend" cr
	  count-file$ $safe-delete
	  red-screen begin halt again
   then
;

\ after runin autoreboot 3times
: reboot-count   ( -- )
   count-file$
   $read-file  if                                         ( )
      ." This is first loop" cr
      ." Creating " count-file$ type cr
      " 1" to count-data$
      count-file$ write-int
   else                                                   ( file-data$ )
      2dup " 3" $= if
         ." We have reboot 3 times" cr
         cr ." Now do normal process..." cr
         d# 3000 ms
         exit
      else
         2dup " We have reboot %s times" sprintf type cr  ( file-data$ )	
         to count-data$                                   ( )
         base @ >r d# 10 base !                           ( )
         count-data$ $number drop                         ( n )
         1+ " %d" sprintf to count-data$                  ( )
         count-file$ $safe-delete
         count-file$ write-int
         cr ." Now is the " count-data$ type ." th times" cr cr
         r> base !
      then
   then
   s3-power-test
   reboot
   d# 10000 ms
;

: fail-backup-file$  ( -- name$ )
   time&date format-date " int:\runin\fail-%s.log" sprintf
;
: fail-log-file$  ( -- name$ )  " int:\runin\fail.log"   ;

\ The operator can type this to reset the state to run
\ the Linux-based runin tests again.
: rerunin  ( -- )
   " int:\runin\final.fth" $safe-delete
   fail-log-file$ fail-backup-file$ do-rename
;

: after-runin  ( -- )
   fail-log-file$ $read-file  0=  if  ( adr len )
      page
      show-fail
      ." Type a key to see the failure log"
      key drop  cr cr
      list
      ." Type R to restart runin, any other key to power off "
      key dup emit cr  upc [char] R =  if
         ." Resetting state to restart runin." cr
         ." The old failure log is in " fail-backup-file$ type cr
         rerunin
      else
         power-off
      then
   else
      reboot-count
      autorun-mfg-tests
      pass?  if
         " int:\runin\final.fth" $safe-delete
		 
         " int:\runin\passfl" $safe-delete 
         " int:\runin\count.txt" " int:\runin\passfl" $safe-rename
		 
         " int:\runin\repass.fth" 2dup $file-exists?  if
         " int:\runin\final.fth" $copy!
         else
            2drop
            ." Do not have repass.fth ,you can't do final download!!!"
            red-screen begin halt again
         then 
      then
      show-result-screen
   then

   ." Type a key to power off ,and pull out the battery"
   key cr
   power-off
;

\ Make the "wait for SD insertion" step highly visible 
dev ext
warning @  warning off
: wait&clear  ( -- error? )  wait-card? page  ;
patch wait&clear wait-card? selftest
: selftest  ( -- )  page show-pass  selftest  ;
warning !
dend

\ Override the display self test
dev /display
warning @  warning off
: selftest  ( -- error? )
   depth d# 16 <  if  false exit  then

   .vertical-bars16     key drop cr
   .horizontal-bars16   key drop cr
    hgradient           key drop cr
    vgradient

   confirm-selftest?
;
warning ! 
device-end

." Starting final phase" cr
after-runin
