: ov-smb-setup  ( -- )
   1 to smb-dly-us
   d# 108 to smb-clock-gpio#
   d# 109 to smb-data-gpio#
   h# 42 to smb-slave
;
: reset-sensor  ( -- )  d# 73 gpio-clr  1 ms  d# 73 gpio-set  ;
: sensor-power-on   ( -- )  d# 150 gpio-set  ;
: sensor-power-off  ( -- )  d# 150 gpio-clr  ;

h# d420a000 h# 1000 mmap constant camera-base
: cl!  ( l adr -- )  camera-base + l!  ;
: cl@  ( adr -- l )  camera-base + l@  ;

h# d428.2000 h# 1000 mmap constant pmu-page-base
: pmu-base  ( -- adr )  pmu-page-base h# 800 +  ;

: start-camera  ( -- )
   \ Enable clocks
   h# 3f pmu-base h# 28 + l!  \ Clock gating - AHB, Internal PIXCLK, AXI clock always on
   h# 0003.805b pmu-base h# 50 + l!  \ PMUA clock config for CCIC - /1, PLL1/16, AXI arb, AXI, perip on

\  h# 0000.0002 h# 88 cl!   \ Clock select - PIXMCLK, 797/2 (PLL1/16) / 2 -> 24.9 MHz
\  h# 4000.0002 h# 88 cl!   \ Clock select -     AXI, 797/2 (PLL1/16) / 2 -> 24.9 MHz
   h# 6000.0002 h# 88 cl!   \ Clock select -    core, 797/2 (PLL1/16) / 2 -> 24.9 MHz

   sensor-power-on  1 ms
   h# 40 cl@  h# 1000.0000 invert and  h# 40 cl!  \ Enable pads

   reset-sensor
   1 ms
;

: ov@  ( reg -- data )  ov-smb-setup smb-byte@  ;
: ov!  ( data reg -- )  ov-smb-setup smb-byte!  ;

: ov-dump  ( -- )
   ." Camera Internal Registers" cr
   ."      0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f" cr
   h# d0 0  do
      i 2 u.r ." :"
      i h# 10 bounds  do  i ov@ 3 u.r  loop  cr
   h# 10 +loop
;

: test-camera-i2c  ( -- )
   start-camera
   ov-smb-setup smb-on
   ov-dump   
;
