fload mmap.fth
hex
h# d4080000 unaligned-mmap constant wdt-pa
main-pmu-pa h# 200 + unaligned-mmap constant wdtpcr
main-pmu-pa h# 1020 +  unaligned-mmap constant pmu-prr-pj
: io@ @ ;
: io! ! ;

: enable-wdt-clock
   pmu-prr-pj  dup io@  h# 10 or  swap io!  \ enable wdt 2 clock  PMUM_PRR_PJ
   wdtpcr io@  dup  h# 7 or wdtpcr io!  h# 3 or wdtpcr io!
;

: (wdt!)  ( value offset -- )  wdt-pa +  io!  ;
: wdt!  ( value offset -- )
   h# baba h# 9c (wdt!)   h# eb10 h# a0 (wdt!)  ( value offset )
   (wdt!)
;
: wdt@  ( offset -- value )  wdt-pa +  io@  ;

d# 7680 value wdt-short  \   30 seconds at 256 Hz.
d# 65280 value wdt-long  \  255 seconds at 256 Hz.
wdt-long value wdt-time

: wdt-ping
   h# 6c wdt@           ( wvr )         \ read the value register
   1 h# 98 wdt!         ( wvr )         \ clear the counter register
   .d cr                                \ print the value before the clear
;

: wdt-start  ( -- )
   enable-wdt-clock
   wdt-time h# 68 wdt!   \ set match register
   3 h# 64 wdt!   \ match enable: enable counting, enable reset
   wdt-ping
;

: wdt-stop  ( -- )
   2 h# 64 wdt!   \ match enable: disable counting, enable reset
;

: wdt-reset?  ( -- flag )  h# 70 wdt@  1 and  ;

: wdt-check  wdt-reset? .d cr  ;
